"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from datetime import datetime
from exfunc.types import BaseModel
from typing import Optional
from typing_extensions import NotRequired, TypedDict


class GoogleNewsTypedDict(TypedDict):
    title: NotRequired[str]
    r"""The title of the news article"""
    link: NotRequired[str]
    r"""The URL link to the news article"""
    snippet: NotRequired[str]
    r"""A brief snippet or summary of the news article"""
    photo_url: NotRequired[str]
    r"""The URL of the photo associated with the news article"""
    published_datetime_utc: NotRequired[datetime]
    r"""The publication date and time in UTC"""
    source_url: NotRequired[str]
    r"""The URL of the source website"""
    source_name: NotRequired[str]
    r"""The name of the news source"""


class GoogleNews(BaseModel):
    title: Optional[str] = None
    r"""The title of the news article"""

    link: Optional[str] = None
    r"""The URL link to the news article"""

    snippet: Optional[str] = None
    r"""A brief snippet or summary of the news article"""

    photo_url: Optional[str] = None
    r"""The URL of the photo associated with the news article"""

    published_datetime_utc: Optional[datetime] = None
    r"""The publication date and time in UTC"""

    source_url: Optional[str] = None
    r"""The URL of the source website"""

    source_name: Optional[str] = None
    r"""The name of the news source"""
