"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from datetime import datetime
from exfunc.types import BaseModel
from typing import List, Optional
from typing_extensions import NotRequired, TypedDict


class GoogleProductReviewTypedDict(TypedDict):
    review_id: NotRequired[str]
    r"""The unique identifier for the review"""
    title: NotRequired[str]
    r"""The title of the review"""
    author: NotRequired[str]
    r"""The author of the review"""
    source: NotRequired[str]
    r"""The source where the review was published"""
    source_url: NotRequired[str]
    r"""The URL link to the review source"""
    text: NotRequired[str]
    r"""The text content of the review"""
    rating: NotRequired[float]
    r"""The rating given in the review"""
    datetime_utc: NotRequired[datetime]
    r"""The date and time when the review was published in UTC"""
    photos: NotRequired[List[str]]
    r"""An array of URLs for photos included in the review"""


class GoogleProductReview(BaseModel):
    review_id: Optional[str] = None
    r"""The unique identifier for the review"""

    title: Optional[str] = None
    r"""The title of the review"""

    author: Optional[str] = None
    r"""The author of the review"""

    source: Optional[str] = None
    r"""The source where the review was published"""

    source_url: Optional[str] = None
    r"""The URL link to the review source"""

    text: Optional[str] = None
    r"""The text content of the review"""

    rating: Optional[float] = None
    r"""The rating given in the review"""

    datetime_utc: Optional[datetime] = None
    r"""The date and time when the review was published in UTC"""

    photos: Optional[List[str]] = None
    r"""An array of URLs for photos included in the review"""
